<template>
    <section class="sg-blog-section sg-filter" :class="activeClass">
      <div class="container">
        <div class="title blog-header justify-content-between">
          <h1>Recipes</h1>
          <div class="right-content">
            <select v-model="form.sort" @change="filterBlogs" class="form-control">
              <option value="newest">{{ lang.newest }}</option>
              <option value="oldest">{{ lang.oldest }}</option>
              <option value="viewed">{{ lang.most_viewed }}</option>
            </select>
            <div class="d-flex gap-3">
              <div class="sg-search">
                <div class="search-form blog-search">
                  <form @submit.prevent="filterBlogs">
                    <input type="text" class="form-control" v-model="form.title" :placeholder="lang.search_blog">
                    <loading_button v-if="loading"></loading_button>
                    <button v-else type="submit"><span class="mdi mdi-name mdi-magnify">
                      <svg width="20" height="20" viewBox="0 0 32 32" fill="none" xmlns="http://www.w3.org/2000/svg">
                        <path d="M14.2 6.04998C18.7563 6.04998 22.45 9.74363 22.45 14.3M23.537 23.6306L30.7 30.8M27.4 14.3C27.4 21.5902 21.4902 27.5 14.2 27.5C6.90984 27.5 1 21.5902 1 14.3C1 7.00981 6.90984 1.09998 14.2 1.09998C21.4902 1.09998 27.4 7.00981 27.4 14.3Z" stroke="#660F1F" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"/>
                      </svg>
					          </span></button>
                  </form>
                </div>
              </div>
              <ul class="filter-tabs global-list">
                <li class="grid-view-tab" @click="activeClass = 'grid-view-tab'"
                    :class="{'active' : activeClass == 'grid-view-tab' || activeClass == ''}">
                  <span class="mdi mdi-name mdi-grid"></span></li>
                <li class="list-view-tab" @click="activeClass = 'list-view-tab'"
                    :class="{'active' : activeClass == 'list-view-tab' }">
                  <span class="mdi mdi-name mdi-format-list-bulleted"></span></li>
              </ul>
            </div>
          </div>
        </div>
        <div class="row" v-if="true && is_shimmer">
          <div class="col-md-6 col-lg-3 add_margin" v-for="(blog,i) in recipes.data" :key="i">
            <div class="post">
              <div class="entry-header">
                <div class="entry-thumbnail">
                  	<router-link :to="{ name: 'recipe.details',params:{slug:blog.slug}}"><img
                      loading="lazy" :src="blog.thumbnail" :alt="blog.title"
                      class="img-fluid"></router-link>
                </div>
              </div>
              <div class="entry-content">
                <router-link :to="{ name: 'recipe.details',params:{slug:blog.slug}}">
                  <h1 class="entry-title text-ellipse">{{ blog.title }}</h1>
                </router-link>
                <p class="inner_recipe">{{ blog.short_description }}</p>
                <router-link  class="mm" :to="{ name: 'recipe.details',params:{slug:blog.slug}}">
                  {{ lang.read_more }}
                </router-link>
              </div>
            </div>
          </div>
        </div><!-- /.row -->
        <div class="row" v-else-if="shimmer">
          <div class="col-md-6 col-lg-3 add_margin" v-for="(blog,i) in 12" :key="i">
            <div class="post">
              <shimmer></shimmer>
            </div>
          </div>
        </div><!-- /.row -->
        <div class="show-more mt-4" v-if="next_page_url && !loading">
          <a href="javaScript:void(0)" @click="loadMoreData()" class="btn btn-primary">{{ lang.show_more }}</a>
        </div>
        <div class="col-md-12 text-center show-more" v-show="loading">
          <loading_button :class_name="'btn btn-primary'"></loading_button>
        </div>
      </div><!-- /.container -->
    </section>
  </template>
  
  <script>
  import shimmer from "../partials/shimmer";
  import Search from '../homepage/Search.vue';
  
  export default {
    name: "recipes",
    data() {
      return {
        page: 1,
        activeClass: "",
        form: {
          sort: 'newest',
          slug: this.$route.params.slug,
          title: null,
        },
        loading: false,
        is_shimmer: false,
        next_page_url: false,
  
      }
    },
    components: {
      shimmer , Search
    },
    mounted() {
      if (this.lengthCounter(this.recipes) == 0) {
        this.allBlogs();
      }
      if (this.lengthCounter(this.recipes) > 0) {
        this.is_shimmer = true
      }
    },
    computed: {
    recipes() {
        return this.$store.getters.getRecipes;
    },
    shimmer() {
        return this.$store.state.module.shimmer
    },
    },
    watch: {
      $route(from) {
        if (from.name == 'recipes') {
          this.form.slug = null;
        }
  
        this.$store.dispatch('recipes', this.form);
      }
    },
    methods: {
      loadMoreData() {
        this.loading = true
        this.$Progress.start();
        axios.get(this.next_page_url, {params: this.form}).then((response) => {
          if (response.data.error) {
            toastr.error(response.data.error, this.lang.Error + ' !!');
          } else {
            this.loading = false
            let recipes = response.data.recipe.data;
  
            if (recipes.length > 0) {
              for (let i = 0; i < recipes.length; i++) {
                this.recipes.data.push(recipes[i]);
              }
            }
            this.$Progress.finish();
          }
          this.next_page_url = response.data.recipe.next_page_url;
        });
      },
      filterBlogs() {
        this.page = 1;
        this.allBlogs(this.form);
      },
      allBlogs() {
        this.loading = true;
        let url = this.getUrl('home/recipes?page=1')
        axios.get(url, {params: this.form}).then((response) => {
          console.log(response,'iiiii');
          this.is_shimmer = true;
          this.loading = false;
          if (response.data.error) {
            this.$Progress.fail();
            toastr.error(response.data.error, this.lang.Error + ' !!');
          } 
          else {
            this.$store.commit("getRecipes", response.data.recipe);
            this.next_page_url = response.data.recipe.next_page_url;
            this.page++;
            this.$Progress.finish();
          }
  
        }).catch((error) => {
          this.loading = false;
          this.is_shimmer = true
          this.$Progress.fail();
  
          if (error.response && error.response.status == 422) {
            toastr.error(response.data.error, this.lang.Error + ' !!');
          }
        })
      },
    }
  
  }
  </script>
  <style scoped>
  p{
      color:#005186;
      font-size: 13px;
  }
  .mm{
    color:#660F1F;
    position: absolute;
    bottom: 0;
    left: 0;
    margin: 10px;
  }
  .post{
    height:100%;
    margin-bottom: 15px;
    border-radius: 4px;
    background-color: #FFF9F2;
    border: 1px solid #efefef;
    text-align: center;
    position: relative;
  }
.title {
	border-bottom: none;
	margin-bottom: 0;
  }
  .title h1{
	margin-bottom: 0;
  }
  .post {
	margin-bottom: 30px;
	border: 1px solid #eeeeee;
	border-radius: 10px !important;
	box-shadow: 0px 0px 4px 0px #00000040;
	background-color: #FFFAF5 !important;
}
.post .entry-thumbnail {
	height: 176px;
}
.post .entry-thumbnail img {
	width: 100%;
	height: 100%;
	object-fit: contain;
	border-radius: 10px 10px 0 0;
}
.add_margin {
  margin-top: 15px;
}
/* .search_icon :deep() svg rect {
	stroke: none;
  } */
  </style>
  